#ifndef __PMSCAN_H__
#define __PMSCAN_H__

#define PMSCAN_ESC             0x01  
#define PMSCAN_ONE             0x02  
#define PMSCAN_TWO             0x03  
#define PMSCAN_THREE           0x04  
#define PMSCAN_FOUR            0x05  
#define PMSCAN_FIVE            0x06  
#define PMSCAN_SIX             0x07  
#define PMSCAN_SEVEN           0x08  
#define PMSCAN_EIGHT           0x09  
#define PMSCAN_NINE            0x0a  
#define PMSCAN_ZERO            0x0b  
#define PMSCAN_HYPHEN          0x0c  
#define PMSCAN_EQUAL           0x0d  
#define PMSCAN_BACKSPACE       0x0e  
#define PMSCAN_TAB             0x0f  
#define PMSCAN_Q               0x10  
#define PMSCAN_W               0x11  
#define PMSCAN_E               0x12  
#define PMSCAN_R               0x13  
#define PMSCAN_T               0x14  
#define PMSCAN_Y               0x15  
#define PMSCAN_U               0x16  
#define PMSCAN_I               0x17  
#define PMSCAN_O               0x18  
#define PMSCAN_P               0x19  
#define PMSCAN_BRACKETLEFT     0x1a  
#define PMSCAN_BRACKETRIGHT    0x1b  
#define PMSCAN_ENTER           0x1c  
#define PMSCAN_CTRLLEFT        0x1d  
#define PMSCAN_A               0x1e  
#define PMSCAN_S               0x1f  
#define PMSCAN_D               0x20  
#define PMSCAN_F               0x21  
#define PMSCAN_G               0x22  
#define PMSCAN_H               0x23  
#define PMSCAN_J               0x24  
#define PMSCAN_K               0x25  
#define PMSCAN_L               0x26  
#define PMSCAN_SEMICOLON       0x27  
#define PMSCAN_QUOTESINGLE     0x28  
#define PMSCAN_GRAVE           0x29  
#define PMSCAN_SHIFTLEFT       0x2a  
#define PMSCAN_BACKSLASH       0x2b  
#define PMSCAN_Z               0x2c  
#define PMSCAN_X               0x2d  
#define PMSCAN_C               0x2e  
#define PMSCAN_V               0x2f  
#define PMSCAN_B               0x30  
#define PMSCAN_N               0x31  
#define PMSCAN_M               0x32  
#define PMSCAN_COMMA           0x33  
#define PMSCAN_PERIOD          0x34  
#define PMSCAN_SLASH           0x35  
#define PMSCAN_SHIFTRIGHT      0x36  
#define PMSCAN_PADASTERISK     0x37  
#define PMSCAN_ALTLEFT         0x38  
#define PMSCAN_SPACE           0x39  
#define PMSCAN_CAPSLOCK        0x3a  
#define PMSCAN_F1              0x3b  
#define PMSCAN_F2              0x3c  
#define PMSCAN_F3              0x3d  
#define PMSCAN_F4              0x3e  
#define PMSCAN_F5              0x3f  
#define PMSCAN_F6              0x40  
#define PMSCAN_F7              0x41  
#define PMSCAN_F8              0x42  
#define PMSCAN_F9              0x43  
#define PMSCAN_F10             0x44  
#define PMSCAN_NUMLOCK         0x45  
#define PMSCAN_SCROLLLOCK      0x46  
#define PMSCAN_PAD7            0x47  
#define PMSCAN_PAD8            0x48  
#define PMSCAN_PAD9            0x49  
#define PMSCAN_PADMINUS        0x4a  
#define PMSCAN_PAD4            0x4b  
#define PMSCAN_PAD5            0x4c  
#define PMSCAN_PAD6            0x4d  
#define PMSCAN_PADPLUS         0x4e  
#define PMSCAN_PAD1            0x4f  
#define PMSCAN_PAD2            0x50  
#define PMSCAN_PAD3            0x51  
#define PMSCAN_PAD0            0x52  
#define PMSCAN_PADPERIOD       0x53  
#define PMSCAN_SYSREQ          0x54  
#define PMSCAN_RESET           0x55  
#define PMSCAN_EXTRA           0x56  
#define PMSCAN_F11             0x57  
#define PMSCAN_F12             0x58  
#define PMSCAN_BACKTAB         0x59  
#define PMSCAN_PADENTER        0x5a  
#define PMSCAN_CTRLRIGHT       0x5b  
#define PMSCAN_PADSLASH        0x5c  
#define PMSCAN_PRINT           0x5d  
#define PMSCAN_ALTRIGHT        0x5e  
#define PMSCAN_PAUSE           0x5f  
#define PMSCAN_HOME            0x60  
#define PMSCAN_UP              0x61  
#define PMSCAN_PAGEUP          0x62  
#define PMSCAN_LEFT            0x63  
#define PMSCAN_RIGHT           0x64  
#define PMSCAN_END             0x65  
#define PMSCAN_DOWN            0x66  
#define PMSCAN_PAGEDOWN        0x67  
#define PMSCAN_INSERT          0x68  
#define PMSCAN_DELETE          0x69  
#define PMSCAN_F23             0x6a  
#define PMSCAN_F24             0x6b  
#define PMSCAN_SYSMEM          0x6c  
#define PMSCAN_ERASEEOF        0x6d  
#define PMSCAN_BREAK           0x6e  
#define PMSCAN_MOVEWIN         0x6f  
#define PMSCAN_NLS3            0x70  
#define PMSCAN_HELP            0x71  
#define PMSCAN_TASKMAN         0x72  
#define PMSCAN_JEXTRA          0x73  
#define PMSCAN_B11             0x73
#define PMSCAN_JUMP            0x74  
#define PMSCAN_MINWIN          0x75  
#define PMSCAN_CLEAR           0x76  
#define PMSCAN_77              0x77  
#define PMSCAN_78              0x78  
#define PMSCAN_NLS2            0x79  
#define PMSCAN_SIZE            0x7a  
#define PMSCAN_NLS1            0x7b  
#define PMSCAN_APPLICATION     0x7c  
#define PMSCAN_YEN             0x7d  
#define PMSCAN_E13             0x7d
#define PMSCAN_WINLEFT         0x7e  
#define PMSCAN_WINRIGHT        0x7f  
#define PMSCAN_PA1             0x80  
#define PMSCAN_F13             0x81  
#define PMSCAN_F14             0x82  
#define PMSCAN_F15             0x83  
#define PMSCAN_PA2             0x84  
#define PMSCAN_PA3             0x85  
#define PMSCAN_SPACEBREAK      0x86  
#define PMSCAN_TABRIGHT        0x87  
#define PMSCAN_NOOP            0x88  
#define PMSCAN_F16             0x89  
#define PMSCAN_F17             0x8a  
#define PMSCAN_F18             0x8b  
#define PMSCAN_F19             0x8c  
#define PMSCAN_F20             0x8d  
#define PMSCAN_F21             0x8e  
#define PMSCAN_F22             0x8f  

#endif
