/* $Id: kAVLPV.c,v 1.3 2001/10/23 02:13:23 bird Exp $
 *
 * kAVLStr - AVL tree for strings. Unique keys.
 *
 * Copyright (c) 2001 knut st. osmundsen (knut.stange.osmundsen@mynd.no)
 *
 * Project Odin Software License can be found in LICENSE.TXT
 *
 */
#ifndef NOFILEID
static const char szFileId[] = "$Id: kAVLPV.c,v 1.3 2001/10/23 02:13:23 bird Exp $";
#endif

/*******************************************************************************
*   Defined Constants And Macros                                               *
*******************************************************************************/
/*
 * AVL configuration.
 */
#define KAVL_FN(a)                  AVLPV##a
#define KAVL_MAX_STACK              27  /* Up to 2^24 nodes. */
#define KAVL_CHECK_FOR_EQUAL_INSERT 1   /* No duplicate keys! */
#define AVLNODECORE                 AVLPVNODECORE
#define PAVLNODECORE                PAVLPVNODECORE
#define PPAVLNODECORE               PPAVLPVNODECORE
#define AVLKEY                      AVLPVKEY
#define PAVLKEY                     PAVLPVKEY
#define AVLENUMDATA                 AVLPVENUMDATA
#define PAVLENUMDATA                PAVLPVENUMDATA
#define PAVLCALLBACK                PAVLPVCALLBACK


/*
 * AVL Compare macros
 */
#define AVL_L(key1, key2)   ((const char*)key1 <  (const char*)key2)
#define AVL_LE(key1, key2)  ((const char*)key1 <= (const char*)key2)
#define AVL_G(key1, key2)   ((const char*)key1 >  (const char*)key2)
#define AVL_GE(key1, key2)  ((const char*)key1 >= (const char*)key2)
#define AVL_E(key1, key2)   ((const char*)key1 == (const char*)key2)
#define AVL_NE(key1, key2)  ((const char*)key1 != (const char*)key2)


/*******************************************************************************
*   Header Files                                                               *
*******************************************************************************/
#include <kTypes.h>
#include <kAssert.h>
#include <kAVL.h>
#include <kLog.h>

#include <string.h>


/*
 * Include the code.
 */
#include "kAVLBase.c.h"
#include "kAVLGet.c.h"
#include "kAVLGetWithParent.c.h"
#include "kAVLGetWithAdjacentNodes.c.h"
#include "kAVLGetBestFit.c.h"
#include "kAVLRemoveBestFit.c.h"
#include "kAVLEnum.c.h"
#include "kAVLDoWithAll.c.h"

