/* $Id: kAVLStr.c,v 1.2 2001/10/23 02:13:23 bird Exp $
 *
 * kAVLStr - AVL tree for strings. Unique keys.
 *
 * Copyright (c) 2001 knut st. osmundsen (knut.stange.osmundsen@mynd.no)
 *
 * Project Odin Software License can be found in LICENSE.TXT
 *
 */
#ifndef NOFILEID
static const char szFileId[] = "$Id: kAVLStr.c,v 1.2 2001/10/23 02:13:23 bird Exp $";
#endif

/*******************************************************************************
*   Defined Constants And Macros                                               *
*******************************************************************************/
/*
 * AVL configuration.
 */
#define KAVL_FN(a)                  AVLStr##a
#define KAVL_MAX_STACK              27  /* Up to 2^24 nodes. */
#define KAVL_CHECK_FOR_EQUAL_INSERT 1   /* No duplicate keys! */
#define AVLNODECORE                 AVLSTRNODECORE
#define PAVLNODECORE                PAVLSTRNODECORE
#define PPAVLNODECORE               PPAVLSTRNODECORE
#define AVLKEY                      AVLSTRKEY
#define PAVLKEY                     PAVLSTRKEY
#define AVLENUMDATA                 AVLSTRENUMDATA
#define PAVLENUMDATA                PAVLSTRENUMDATA
#define PAVLCALLBACK                PAVLSTRCALLBACK


/*
 * AVL Compare macros
 */
#define AVL_L(key1, key2)   (strcmp(key1, key2) <  0)
#define AVL_LE(key1, key2)  (strcmp(key1, key2) <= 0)
#define AVL_G(key1, key2)   (strcmp(key1, key2) >  0)
#define AVL_GE(key1, key2)  (strcmp(key1, key2) >= 0)
#define AVL_E(key1, key2)   (strcmp(key1, key2) == 0)
#define AVL_NE(key1, key2)  (strcmp(key1, key2) != 0)
#define AVL_CMP(key1, key2)  strcmp(key1, key2)


/*******************************************************************************
*   Header Files                                                               *
*******************************************************************************/
#include <kTypes.h>
#include <kAssert.h>
#include <kAVL.h>
#include <kLog.h>

#include <string.h>


#include "kAVLBase.c.h"
#include "kAVLGet.c.h"
#include "kAVLEnum.c.h"
#include "kAVLDoWithAll.c.h"
