/* $Id: kAVLStrI.c,v 1.2 2001/10/23 02:13:24 bird Exp $
 *
 * kAVLStrI - AVL tree for case insensitive strings. Unique keys.
 *
 * Copyright (c) 2001 knut st. osmundsen (knut.stange.osmundsen@mynd.no)
 *
 * Project Odin Software License can be found in LICENSE.TXT
 *
 */
#ifndef NOFILEID
static const char szFileId[] = "$Id: kAVLStrI.c,v 1.2 2001/10/23 02:13:24 bird Exp $";
#endif

/*******************************************************************************
*   Defined Constants And Macros                                               *
*******************************************************************************/
/*
 * AVL configuration.
 */
#define KAVL_FN(a)                  AVLStrI##a
#define KAVL_MAX_STACK              27  /* Up to 2^24 nodes. */
#define KAVL_CHECK_FOR_EQUAL_INSERT 1   /* No duplicate keys! */
#define AVLNODECORE                 AVLSTRINODECORE
#define PAVLNODECORE                PAVLSTRINODECORE
#define PPAVLNODECORE               PPAVLSTRINODECORE
#define AVLKEY                      AVLSTRIKEY
#define PAVLKEY                     PAVLSTRIKEY
#define AVLENUMDATA                 AVLSTRIENUMDATA
#define PAVLENUMDATA                PAVLSTRIENUMDATA
#define PAVLCALLBACK                PAVLSTRICALLBACK


/*
 * AVL Compare macros
 */
#define AVL_L(key1, key2)   (stricmp(key1, key2) <  0)
#define AVL_LE(key1, key2)  (stricmp(key1, key2) <= 0)
#define AVL_G(key1, key2)   (stricmp(key1, key2) >  0)
#define AVL_GE(key1, key2)  (stricmp(key1, key2) >= 0)
#define AVL_E(key1, key2)   (stricmp(key1, key2) == 0)
#define AVL_NE(key1, key2)  (stricmp(key1, key2) != 0)
#define AVL_CMP(key1, key2)  stricmp(key1, key2)


/*******************************************************************************
*   Header Files                                                               *
*******************************************************************************/
#include <kTypes.h>
#include <kAssert.h>
#include <kAVL.h>
#include <kLog.h>

#include <string.h>


#include "kAVLBase.c.h"
#include "kAVLGet.c.h"
#include "kAVLEnum.c.h"
#include "kAVLDoWithAll.c.h"
