/* $Id: kAVLULM.c,v 1.3 2001/10/23 02:13:24 bird Exp $
 *
 * kAVLULM - AVL tree for unsigned long values. Duplicate keys allowed.
 *           AVLCore includes pList.
 *
 * Copyright (c) 2001 knut st. osmundsen (knut.stange.osmundsen@mynd.no)
 *
 * Project Odin Software License can be found in LICENSE.TXT
 *
 */
#ifndef NOFILEID
static const char szFileId[] = "$Id: kAVLULM.c,v 1.3 2001/10/23 02:13:24 bird Exp $";
#endif

/*******************************************************************************
*   Defined Constants And Macros                                               *
*******************************************************************************/
/*
 * AVL configuration.
 */
#define KAVL_FN(a)                  AVLULM##a
#define KAVL_EQUAL_ALLOWED          1
#define KAVL_MAX_STACK              27  /* Up to 2^24 nodes. */
#define AVLNODECORE                 AVLULMNODECORE
#define PAVLNODECORE                PAVLULMNODECORE
#define PPAVLNODECORE               PPAVLULMNODECORE
#define AVLKEY                      AVLULMKEY
#define PAVLKEY                     PAVLULMKEY
#define AVLENUMDATA                 AVLULMENUMDATA
#define PAVLENUMDATA                PAVLULMENUMDATA
#define PAVLCALLBACK                PAVLULMCALLBACK


/*
 * AVL Compare macros
 */
#define AVL_L(key1, key2)   (key1 <  key2)
#define AVL_LE(key1, key2)  (key1 <= key2)
#define AVL_G(key1, key2)   (key1 >  key2)
#define AVL_GE(key1, key2)  (key1 >= key2)
#define AVL_E(key1, key2)   (key1 == key2)
#define AVL_NE(key1, key2)  (key1 != key2)


/*******************************************************************************
*   Header Files                                                               *
*******************************************************************************/
#include <kTypes.h>
#include <kAssert.h>
#include <kAVL.h>
#include <kLog.h>

#include <string.h>

/*
 * Include the code.
 */
#include "kAVLBase.c.h"
#include "kAVLGet.c.h"
#include "kAVLGet2.c.h"
#include "kAVLRemove2.c.h"
#include "kAVLGetWithParent.c.h"
#include "kAVLGetWithAdjacentNodes.c.h"
#include "kAVLGetBestFit.c.h"
#include "kAVLRemoveBestFit.c.h"
#include "kAVLEnum.c.h"
#include "kAVLDoWithAll.c.h"

