/* $Id: kAssert.c,v 1.3 2001/10/23 02:13:24 bird Exp $
 *
 * kAssert - Assertion helper functions.
 *
 * Copyright (c) 2001 knut st. osmundsen (knut.stange.osmundsen@mynd.no)
 *
 * GPL
 *
 */
#ifndef NOFILEID
static const char szFileId[] = "$Id: kAssert.c,v 1.3 2001/10/23 02:13:24 bird Exp $";
#endif


/*******************************************************************************
*   Header Files                                                               *
*******************************************************************************/
#include "kAssert.h"
#include "kTypes.h"
#include "kLog.h"


/**
 * This function will display and log assertions which failes.
 * @returns TRUE:   issue breakpoint instruction
 *          FALSE:  continue execution.
 * @param   pszExpr
 * @param   pszFilename     Name of the file the kASSERT macro is called from.
 * @param   uLine           Line number (within pszFilename) of the kASSERT macro call.
 * @param   pszFunction     Name of the function the kASSERT macro is called from.
 * @author  knut st. osmundsen (knut.stange.osmundsen@mynd.no)
 */
KBOOL KLIBCALL kAssertMsg(const char *pszExpr, const char *pszFilename, unsigned uLine, const char *pszFunction)
{
    #if 1
    kLog(KLOGMODHANDLE, pszFilename, uLine, pszFunction, KLOG_TYPE_ASSERT, pszExpr);
    #else
    kLog(KLOGMODHANDLE, pszFilename, uLine, KLOG_TYPE_ASSERT, pszExpr);
    #endif
    return TRUE;
}

