/* $Id: kLogAVLUL.c,v 1.1 2001/11/15 04:18:45 bird Exp $
 *
 * kLogAVLStr - AVL tree for strings. Unique keys. No logging.
 *
 * Copyright (c) 2001 knut st. osmundsen (knut.stange.osmundsen@mynd.no)
 *
 * Project Odin Software License can be found in LICENSE.TXT
 *
 */

/*******************************************************************************
*   Defined Constants And Macros                                               *
*******************************************************************************/
/*
 * AVL configuration.
 */
#define KAVL_FN(a)                  AVLULNL##a
#define KAVL_MAX_STACK              27  /* Up to 2^24 nodes. */
#define KAVL_CHECK_FOR_EQUAL_INSERT 1   /* No duplicate keys! */
#define AVLNODECORE                 AVLULNODECORE
#define PAVLNODECORE                PAVLULNODECORE
#define PPAVLNODECORE               PPAVLULNODECORE
#define AVLKEY                      AVLULKEY
#define PAVLKEY                     PAVLULKEY
#define AVLENUMDATA                 AVLULENUMDATA
#define PAVLENUMDATA                PAVLULENUMDATA
#define PAVLCALLBACK                PAVLULCALLBACK


/*
 * AVL Compare macros
 */
#define AVL_L(key1, key2)   ((const char*)key1 <  (const char*)key2)
#define AVL_LE(key1, key2)  ((const char*)key1 <= (const char*)key2)
#define AVL_G(key1, key2)   ((const char*)key1 >  (const char*)key2)
#define AVL_GE(key1, key2)  ((const char*)key1 >= (const char*)key2)
#define AVL_E(key1, key2)   ((const char*)key1 == (const char*)key2)
#define AVL_NE(key1, key2)  ((const char*)key1 != (const char*)key2)


/*******************************************************************************
*   Header Files                                                               *
*******************************************************************************/
#include <kTypes.h>
#include <kAssert.h>
#include <kAVL.h>
#undef DEBUG
#undef LOGGING_ENABLED
#include <kLog.h>

#include <string.h>


#include "kAVLBase.c.h"
#include "kAVLGet.c.h"

